#Disable warnings in 3rdparty code due to unused arguments
win32-msvc* {
    QMAKE_CXXFLAGS_WARN_ON += /wd4100
}
*-g++* {
    QMAKE_CFLAGS_WARN_ON += -Wno-unused-parameter -Wno-main
}
clang {
    QMAKE_CXXFLAGS_WARN_ON += -Wno-unused-parameter -Wno-deprecated-declarations -Wno-sign-compare -Wno-delete-non-virtual-dtor
}

DEFINES += TAGLIB_STATIC

INCLUDEPATH += \
    $$PWD/ \
    $$PWD/taglib \
    $$PWD/taglib/taglib \
    $$PWD/taglib/taglib/ape \
    $$PWD/taglib/taglib/asf \
    $$PWD/taglib/taglib/flac \
    $$PWD/taglib/taglib/it \
    $$PWD/taglib/taglib/mod \
    $$PWD/taglib/taglib/mp4 \
    $$PWD/taglib/taglib/mpc \
    $$PWD/taglib/taglib/mpeg \
    $$PWD/taglib/taglib/mpeg/id3v1 \
    $$PWD/taglib/taglib/mpeg/id3v2 \
    $$PWD/taglib/taglib/mpeg/id3v2/frames \
    $$PWD/taglib/taglib/ogg \
    $$PWD/taglib/taglib/ogg/flac \
    $$PWD/taglib/taglib/ogg/opus \
    $$PWD/taglib/taglib/ogg/speex \
    $$PWD/taglib/taglib/ogg/vorbis \
    $$PWD/taglib/taglib/riff \
    $$PWD/taglib/taglib/riff/aiff \
    $$PWD/taglib/taglib/riff/wav \
    $$PWD/taglib/taglib/s3m \
    $$PWD/taglib/taglib/toolkit \
    $$PWD/taglib/taglib/trueaudio \
    $$PWD/taglib/taglib/wavpack \
    $$PWD/taglib/taglib/xm \


HEADERS += \
    $$PWD/taglib/taglib/mp4/mp4properties.h \
    $$PWD/taglib/taglib/mp4/mp4file.h \
    $$PWD/taglib/taglib/mp4/mp4tag.h \
    $$PWD/taglib/taglib/mp4/mp4atom.h \
    $$PWD/taglib/taglib/mp4/mp4item.h \
    $$PWD/taglib/taglib/mp4/mp4coverart.h \
    $$PWD/taglib/taglib/tagutils.h \
    $$PWD/taglib/taglib/toolkit/tzlib.h \
    $$PWD/taglib/taglib/toolkit/tutils.h \
    $$PWD/taglib/taglib/toolkit/tdebuglistener.h \
    $$PWD/taglib/taglib/toolkit/tlist.h \
    $$PWD/taglib/taglib/toolkit/trefcounter.h \
    $$PWD/taglib/taglib/toolkit/tbytevectorstream.h \
    $$PWD/taglib/taglib/toolkit/tmap.h \
    $$PWD/taglib/taglib/toolkit/taglib.h \
    $$PWD/taglib/taglib/toolkit/tfilestream.h \
    $$PWD/taglib/taglib/toolkit/tpropertymap.h \
    $$PWD/taglib/taglib/toolkit/tstringlist.h \
    $$PWD/taglib/taglib/toolkit/tbytevector.h \
    $$PWD/taglib/taglib/toolkit/tbytevectorlist.h \
    $$PWD/taglib/taglib/toolkit/tdebug.h \
    $$PWD/taglib/taglib/toolkit/tstring.h \
    $$PWD/taglib/taglib/toolkit/tfile.h \
    $$PWD/taglib/taglib/toolkit/tiostream.h \
    $$PWD/taglib/taglib/audioproperties.h \
    $$PWD/taglib/taglib/xm/xmfile.h \
    $$PWD/taglib/taglib/xm/xmproperties.h \
    $$PWD/taglib/taglib/wavpack/wavpackproperties.h \
    $$PWD/taglib/taglib/wavpack/wavpackfile.h \
    $$PWD/taglib/taglib/tag.h \
    $$PWD/taglib/taglib/ape/apeproperties.h \
    $$PWD/taglib/taglib/ape/apetag.h \
    $$PWD/taglib/taglib/ape/apeitem.h \
    $$PWD/taglib/taglib/ape/apefile.h \
    $$PWD/taglib/taglib/ape/apefooter.h \
    $$PWD/taglib/taglib/tagunion.h \
    $$PWD/taglib/taglib/asf/asffile.h \
    $$PWD/taglib/taglib/asf/asftag.h \
    $$PWD/taglib/taglib/asf/asfpicture.h \
    $$PWD/taglib/taglib/asf/asfutils.h \
    $$PWD/taglib/taglib/asf/asfproperties.h \
    $$PWD/taglib/taglib/asf/asfattribute.h \
    $$PWD/taglib/taglib/it/itproperties.h \
    $$PWD/taglib/taglib/it/itfile.h \
    $$PWD/taglib/taglib/trueaudio/trueaudioproperties.h \
    $$PWD/taglib/taglib/trueaudio/trueaudiofile.h \
    $$PWD/taglib/taglib/s3m/s3mfile.h \
    $$PWD/taglib/taglib/s3m/s3mproperties.h \
    $$PWD/taglib/taglib/fileref.h \
    $$PWD/taglib/taglib/ogg/oggpageheader.h \
    $$PWD/taglib/taglib/ogg/oggfile.h \
    $$PWD/taglib/taglib/ogg/vorbis/vorbisproperties.h \
    $$PWD/taglib/taglib/ogg/vorbis/vorbisfile.h \
    $$PWD/taglib/taglib/ogg/speex/speexfile.h \
    $$PWD/taglib/taglib/ogg/speex/speexproperties.h \
    $$PWD/taglib/taglib/ogg/xiphcomment.h \
    $$PWD/taglib/taglib/ogg/opus/opusproperties.h \
    $$PWD/taglib/taglib/ogg/opus/opusfile.h \
    $$PWD/taglib/taglib/ogg/oggpage.h \
    $$PWD/taglib/taglib/ogg/flac/oggflacfile.h \
    $$PWD/taglib/taglib/mpc/mpcproperties.h \
    $$PWD/taglib/taglib/mpc/mpcfile.h \
    $$PWD/taglib/taglib/taglib_export.h \
    $$PWD/taglib/taglib/flac/flacunknownmetadatablock.h \
    $$PWD/taglib/taglib/flac/flacpicture.h \
    $$PWD/taglib/taglib/flac/flacmetadatablock.h \
    $$PWD/taglib/taglib/flac/flacproperties.h \
    $$PWD/taglib/taglib/flac/flacfile.h \
    $$PWD/taglib/taglib/mod/modfilebase.h \
    $$PWD/taglib/taglib/mod/modfileprivate.h \
    $$PWD/taglib/taglib/mod/modproperties.h \
    $$PWD/taglib/taglib/mod/modtag.h \
    $$PWD/taglib/taglib/mod/modfile.h \
    $$PWD/taglib/taglib/riff/riffutils.h \
    $$PWD/taglib/taglib/riff/aiff/aiffproperties.h \
    $$PWD/taglib/taglib/riff/aiff/aifffile.h \
    $$PWD/taglib/taglib/riff/rifffile.h \
    $$PWD/taglib/taglib/riff/wav/infotag.h \
    $$PWD/taglib/taglib/riff/wav/wavproperties.h \
    $$PWD/taglib/taglib/riff/wav/wavfile.h \
    $$PWD/taglib/taglib/mpeg/xingheader.h \
    $$PWD/taglib/taglib/mpeg/mpegproperties.h \
    $$PWD/taglib/taglib/mpeg/mpegheader.h \
    $$PWD/taglib/taglib/mpeg/mpegfile.h \
    $$PWD/taglib/taglib/mpeg/id3v1/id3v1genres.h \
    $$PWD/taglib/taglib/mpeg/id3v1/id3v1tag.h \
    $$PWD/taglib/taglib/mpeg/mpegutils.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2header.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2extendedheader.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2footer.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2tag.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2synchdata.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/urllinkframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/uniquefileidentifierframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/privateframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/relativevolumeframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/unsynchronizedlyricsframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/commentsframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/tableofcontentsframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/eventtimingcodesframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/podcastframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/textidentificationframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/popularimeterframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/unknownframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/attachedpictureframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/generalencapsulatedobjectframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/synchronizedlyricsframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/chapterframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/ownershipframe.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2frame.h \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2framefactory.h \

SOURCES += \
    $$PWD/taglib/taglib/audioproperties.cpp \
    $$PWD/taglib/taglib/tagutils.cpp \
    $$PWD/taglib/taglib/mp4/mp4coverart.cpp \
    $$PWD/taglib/taglib/mp4/mp4tag.cpp \
    $$PWD/taglib/taglib/mp4/mp4file.cpp \
    $$PWD/taglib/taglib/mp4/mp4properties.cpp \
    $$PWD/taglib/taglib/mp4/mp4atom.cpp \
    $$PWD/taglib/taglib/mp4/mp4item.cpp \
    $$PWD/taglib/taglib/toolkit/tstring.cpp \
    $$PWD/taglib/taglib/toolkit/tpropertymap.cpp \
    $$PWD/taglib/taglib/toolkit/tbytevector.cpp \
    $$PWD/taglib/taglib/toolkit/tbytevectorstream.cpp \
    $$PWD/taglib/taglib/toolkit/tzlib.cpp \
    $$PWD/taglib/taglib/toolkit/tstringlist.cpp \
    $$PWD/taglib/taglib/toolkit/tiostream.cpp \
    $$PWD/taglib/taglib/toolkit/tfilestream.cpp \
    $$PWD/taglib/taglib/toolkit/trefcounter.cpp \
    $$PWD/taglib/taglib/toolkit/tdebug.cpp \
    $$PWD/taglib/taglib/toolkit/tbytevectorlist.cpp \
    $$PWD/taglib/taglib/toolkit/tfile.cpp \
    $$PWD/taglib/taglib/toolkit/tdebuglistener.cpp \
    $$PWD/taglib/taglib/xm/xmfile.cpp \
    $$PWD/taglib/taglib/xm/xmproperties.cpp \
    $$PWD/taglib/taglib/wavpack/wavpackproperties.cpp \
    $$PWD/taglib/taglib/wavpack/wavpackfile.cpp \
    $$PWD/taglib/taglib/ape/apeproperties.cpp \
    $$PWD/taglib/taglib/ape/apetag.cpp \
    $$PWD/taglib/taglib/ape/apefile.cpp \
    $$PWD/taglib/taglib/ape/apeitem.cpp \
    $$PWD/taglib/taglib/ape/apefooter.cpp \
    $$PWD/taglib/taglib/fileref.cpp \
    $$PWD/taglib/taglib/asf/asftag.cpp \
    $$PWD/taglib/taglib/asf/asffile.cpp \
    $$PWD/taglib/taglib/asf/asfproperties.cpp \
    $$PWD/taglib/taglib/asf/asfpicture.cpp \
    $$PWD/taglib/taglib/asf/asfattribute.cpp \
    $$PWD/taglib/taglib/it/itfile.cpp \
    $$PWD/taglib/taglib/it/itproperties.cpp \
    $$PWD/taglib/taglib/trueaudio/trueaudiofile.cpp \
    $$PWD/taglib/taglib/trueaudio/trueaudioproperties.cpp \
    $$PWD/taglib/taglib/s3m/s3mproperties.cpp \
    $$PWD/taglib/taglib/s3m/s3mfile.cpp \
    $$PWD/taglib/taglib/tagunion.cpp \
    $$PWD/taglib/taglib/ogg/oggfile.cpp \
    $$PWD/taglib/taglib/ogg/vorbis/vorbisfile.cpp \
    $$PWD/taglib/taglib/ogg/vorbis/vorbisproperties.cpp \
    $$PWD/taglib/taglib/ogg/oggpageheader.cpp \
    $$PWD/taglib/taglib/ogg/speex/speexproperties.cpp \
    $$PWD/taglib/taglib/ogg/speex/speexfile.cpp \
    $$PWD/taglib/taglib/ogg/xiphcomment.cpp \
    $$PWD/taglib/taglib/ogg/opus/opusproperties.cpp \
    $$PWD/taglib/taglib/ogg/opus/opusfile.cpp \
    $$PWD/taglib/taglib/ogg/oggpage.cpp \
    $$PWD/taglib/taglib/ogg/flac/oggflacfile.cpp \
    $$PWD/taglib/taglib/mpc/mpcfile.cpp \
    $$PWD/taglib/taglib/mpc/mpcproperties.cpp \
    $$PWD/taglib/taglib/flac/flacunknownmetadatablock.cpp \
    $$PWD/taglib/taglib/flac/flacmetadatablock.cpp \
    $$PWD/taglib/taglib/flac/flacpicture.cpp \
    $$PWD/taglib/taglib/flac/flacproperties.cpp \
    $$PWD/taglib/taglib/flac/flacfile.cpp \
    $$PWD/taglib/taglib/mod/modfile.cpp \
    $$PWD/taglib/taglib/mod/modtag.cpp \
    $$PWD/taglib/taglib/mod/modfilebase.cpp \
    $$PWD/taglib/taglib/mod/modproperties.cpp \
    $$PWD/taglib/taglib/tag.cpp \
    $$PWD/taglib/taglib/riff/rifffile.cpp \
    $$PWD/taglib/taglib/riff/aiff/aifffile.cpp \
    $$PWD/taglib/taglib/riff/aiff/aiffproperties.cpp \
    $$PWD/taglib/taglib/riff/wav/wavfile.cpp \
    $$PWD/taglib/taglib/riff/wav/infotag.cpp \
    $$PWD/taglib/taglib/riff/wav/wavproperties.cpp \
    $$PWD/taglib/taglib/mpeg/mpegproperties.cpp \
    $$PWD/taglib/taglib/mpeg/id3v1/id3v1tag.cpp \
    $$PWD/taglib/taglib/mpeg/id3v1/id3v1genres.cpp \
    $$PWD/taglib/taglib/mpeg/mpegheader.cpp \
    $$PWD/taglib/taglib/mpeg/mpegfile.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2synchdata.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2tag.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2framefactory.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2extendedheader.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/relativevolumeframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/generalencapsulatedobjectframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/chapterframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/unsynchronizedlyricsframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/urllinkframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/eventtimingcodesframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/uniquefileidentifierframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/popularimeterframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/tableofcontentsframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/ownershipframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/textidentificationframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/privateframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/attachedpictureframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/commentsframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/synchronizedlyricsframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/podcastframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/frames/unknownframe.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2header.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2frame.cpp \
    $$PWD/taglib/taglib/mpeg/id3v2/id3v2footer.cpp \
    $$PWD/taglib/taglib/mpeg/xingheader.cpp \

!win32: SOURCES += $$PWD/taglib/taglib/toolkit/unicode.cpp
